#ifndef SCS_FUNCTION_H
#define SCS_FUNCTION_H

/*
 *function:    send the buf to the rabbitmq-server
 *parameters:  char * msg
 *return :     0 is correct ,other is error
 */
extern int scs_message_send(char *ip , char* msg);

/*
 *function:    recv the buf from the rabbitmq-server
 *parameters:  char * msg
 *return :     0 is correct ,other is error
 */
extern int scs_message_recv_init(void);

/*
 *function:    recv the buf from the rabbitmq-server
 *parameters:  char * msg
 *return :     0 is correct ,other is error
 */
extern int scs_message_recv(char *msg);

/*
 *function:    recv the buf from the rabbitmq-server
 *parameters:  char * msg
 *return :     0 is correct ,other is error
 */
extern int scs_message_recv_close(void);

/*
 *Function       :   set the rabbitmq paramesters
 *return value   :   void
 *Parameters     :   void
 */
extern void scs_rabbit_config(void);

/*
 *Function     :write the log message to the /var/log/scs.log
 *return value :void
 *Parameters:
 *flags       ：log type（LOG_INFO,LOG_WARN,LOG_ERROR）
 *szFormat    ：for extent the 
 */
extern void scs_write_logs(unsigned int flags,const char *const szFormat,...);

/*
 *Function:去掉字符串头部与尾部的空格
 *return value:void
 *Parameters:
 *  inbuf   ：原始字符串
 *  outbuf  ：处理后字符串
 */
extern void scs_trimSpace(char *inbuf, char *outbuf);


#endif
