#ifndef SCS_INCLUDE_H
#define SCS_INCLUDE_H

#include <assert.h>
#include <arpa/inet.h>
#include <arpa/inet.h>
#include <ctype.h>
#include <errno.h>
#include <fcntl.h>
#include <linux/types.h>
#include <linux/hdreg.h>
#include <netinet/in.h>
#include <net/if.h>
#include <netdb.h>
#include <pwd.h>
#include <resolv.h>
#include <sys/ioctl.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <sys/utsname.h>
#include <sys/statfs.h>
#include <sys/un.h>
#include <stdarg.h>
#include <sys/types.h>
#include <signal.h>
#include <sys/sysinfo.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <unistd.h>
#include <ifaddrs.h>
#include <wchar.h>
#include <malloc.h>
#include <dirent.h>
#include <pthread.h>

#include "scs_amqp.h"
#include "scs_queue.h"
#include "scs_utils.h"


#include "amqp_framing.h"
#include "amqp.h"
#include "amqp_tcp_socket.h"
/*
#include "amqp_private.h"     
#include "amqp_table.h"
#include "amqp_socket.h"
#include "amqp_hostcheck.h"
#include "amqp_ssl_socket.h"
#include "amqp_time.h"
*/

#define LOG_INFO                3
#define LOG_WARN                2
#define LOG_ERROR               1

#define FLAG_SEND               1
#define FLAG_ACK                0

#define RABBIT_SERVER_LENGTH        1024
#define RABBIT_HOST_LENGTH          1024
#define RABBIT_PORT_LENGTH          1024
#define RABBIT_USERID_LENGTH        1024
#define RABBIT_PASSWROD_LENGTH      1024
#define RABBIT_VIRTUAL_HOST_LENGTH  1024
#define RABBIT_EXCHANGE_LENGTH      1024
#define RABBIT_ROUTINGKEY_LENGTH    1024
#define PASSWORD_LENGTH             1024

char rabbit_server[RABBIT_SERVER_LENGTH];
char rabbit_host[RABBIT_HOST_LENGTH];
char rabbit_password[RABBIT_PASSWROD_LENGTH];
char rabbit_userid[RABBIT_USERID_LENGTH];
char rabbit_virtual_host[RABBIT_VIRTUAL_HOST_LENGTH];
char rabbit_exchange[RABBIT_EXCHANGE_LENGTH];
char rabbit_routingkey[RABBIT_ROUTINGKEY_LENGTH];
int  rabbit_port=5672;


int status_recv;                     //amqp_socket_open() return value
amqp_socket_t * socket_recv = NULL;  // amqp_tcp_socket_new() return value
amqp_connection_state_t conn_recv;   // amqp_new_connection() return value
amqp_bytes_t queuename_recv;         // amqp_bytes_malloc_dup() return value

#define RABBIT_AGETN_PATH           "/etc/scs/scs_agent.conf"  //scs_server_daemon use the conf
#define LOG_FILE                    "/var/log/scs.log"  //scs_server_daemon use the conf


#define SCS_MSG_SEND_ERRO -1


#endif
