#!/usr/bin/env python
# -*- coding: utf-8 -*-

# NeoKylin Software Center Client Init.

import pygtk
#pygtk.require('2.0')
import gtk
import pynotify
import sys
import time
import os

if(sys.version[0] == '3'):
    from tkinter import  *
else:
    from Tkinter import  *


def shellExec(cmd):
    return os.popen(cmd).read().strip()

def shellNotify(summary, body_text, time_out):
    if not pynotify.init("Software Center"):
        myprint("Failed to pynotify init")
        return 

    n = pynotify.Notification(summary, body_text)
    n.set_timeout(time_out)
    #n.set_hint("x", 2000)
    #n.set_hint("y", 10) 

    if not n.show():
        myprint("Failed to send notification")
        return

LANGUAGE=shellExec("echo $LANG")
#PS_SOFTCENTER=shellExec("ps -a |grep softCenter |awk '{print $4}'")
PS_SOFTCENTER = shellExec("ps -aux | grep softCenter | grep -v grep | awk '{print $11}'")
INIT_MY_NAME = shellExec("whoami")
INI_DATE= shellExec("ls -l --full-time /opt/softwarecenter/doc/client-config.ini |awk '{print $6 $7}'")
#SC_PPID= shellExec("ps -aux | grep neokylin-software-center_start.sh | grep -v grep | awk '{print $2}'")
SC_PPID= shellExec("ps -aux | grep neokylin-software-center_start.py| grep -v grep | awk '{print $2}'")
SC_PID= shellExec("ps -aux | grep softCenter | grep -v grep | awk '{print $2}'")

# write str to file
def fileWrite(str, file):
    fd = open(file, "w")
    fd.write(str)
    fd.close()

def fileRead():
    STATUS = 0
    patt=r'^ *mysudo *= *yes *$'
    pattern = re.compile(patt)

    fo = open("/opt/softwarecenter/doc/mysudo.conf")
    for line in fo.readlines():
	line = line.strip()
	result = pattern.findall(line)

	if result:
	    STATUS = 1
	    fo.close()
	    return STATUS

    fo.close()
    return STATUS

def myprint(str, property=""):
    if property == 'error':
	text.tag_configure('big', foreground='red', font=('微软雅黑', 12, 'bold'))
	text.insert(END, str, 'big')
    elif property == 'blue':
	text.tag_configure('blue', foreground='blue', font=('微软雅黑', 12, 'bold'))
	text.insert(END, str, 'blue')
    elif property == 'info':
	text.tag_configure('info', foreground='blue', font=('宋体', 12, 'bold'))
	text.insert(END, str, 'info')
    else:
	text.insert(END, str)

    text.pack()
    text.update()


def useradd_fix_for_systemd_update():
    # for erlang-erts %pre
    #if not shellExec("mysudo getent group epmd >/dev/null"):
    empty = shellExec("mysudo getent group epmd")
    if empty == '':
	myprint('Creating group "epmd"\n')
	shellExec("mysudo groupadd -r epmd")
    else:
	myprint('Group "epmd" already exists\n')
    
    #if not shellExec("mysudo getent passwd epmd >/dev/null"):
    empty = shellExec("mysudo getent passwd epmd")
    if empty == '':
	myprint('Creating user "epmd"\n')
	shellExec(r'mysudo useradd -r -g epmd -d /tmp -s /sbin/nologin -c \"Erlang Port Mapper Daemon\" epmd')
    else:
	myprint('User "epmd" already exists\n')

    # for rabbitmq-server %pre
    #if not shellExec("mysudo getent group rabbitmq >/dev/null"):
    empty = shellExec("mysudo getent group rabbitmq")
    if empty == '':
	myprint('Creating group "rabbitmq"\n')
	shellExec("mysudo groupadd -r rabbitmq")
    else:
	myprint('Group "rabbitmq" already exists\n')
    
    #if not shellExec("mysudo getent passwd rabbitmq >/dev/null"):
    empty = shellExec("mysudo getent passwd rabbitmq")
    if empty == '':
	myprint('Creating user "rabbitmq"\n')
	shellExec(r'mysudo useradd -r -g rabbitmq -d /var/lib/rabbitmq rabbitmq -s /sbin/nologin -c \"RabbitMQ messaging server\"')
    else:
	myprint('User "rabbitmq" already exists\n')
    

def check_user():
    i= shellExec("mysudo cat /etc/passwd | cut -f1 -d':' | grep -w '$1' -c")
    if (i == "0"):
	#myprint("User $1 is not in the passwd"
	return 0
    else:
	return 1


def otherLanguage():
    if (INIT_MY_NAME != "root") and (fileRead() != 1):
	myprint("[ERROR] NeoKylin Software Center Initial Script must execute as root\n", 'error')
	myprint("[ERROR] Please edit /opt/softwarecenter/doc/mysudo.conf and then execute the initial script: \n", 'error')
	myprint("\n")
	myprint("     /usr/share/doc/software-center/scc-init.py\n")
	myprint("\n")
	
	shellExec("mysudo rm -rf /opt/softwarecenter/.SOFTINI_DATE_ORIG")
	myprint("[ERROR] EXIT INIT...\n", 'error')
	if (SC_PPID != ""):
	    #kill -9 `echo $SC_PPID`
	    myprint("\n")
	
	shellNotify("Please edit mysudo.conf and then use 'mysudo' to execute :", "/usr/share/doc/software-center/scc-init.py", 20000)
	message = "The current user " + "'s mysudo.conf maybe not true"
	shellNotify("NeoKylin Software Center Init FAILED ! ", message, 5000)

	time.sleep(2)
	sys.exit()

    if (PS_SOFTCENTER == "/usr/sbin/softCenter") :
	myprint("[ERROR] softCenter still running, you can not exec this script.\n", 'error')
	myprint("[ERROR] EXIT\n")
	shellExec("mysudo rm -rf /opt/softwarecenter/.SOFTINI_DATE_ORIG")
	time.sleep(3)
	sys.exit()
    
    myprint("[INFO] Software Center Client Init START\n", 'info')
    myprint("\n")
    myprint("[INFO] configuring rabbitmq-server ...\n", 'info')
    useradd_fix_for_systemd_update()
    shellExec("mysudo systemctl restart rabbitmq-server")
    shellExec("mysudo systemctl enable rabbitmq-server")
    myprint("[INFO] checking rabbitmq-server ...\n", 'info')
    RABBITMQ_SERVER_STATUS = shellExec("mysudo systemctl list-units --all --type=service |grep rabbitmq-server |awk '{print $4}'")
    if (RABBITMQ_SERVER_STATUS != "running"):
	STATUS = "[WARNING] rabbitmq-server is" + RABBITMQ_SERVER_STATUS + "\n"
	myprint(STATUS)
	myprint("[WARNING] try to restart service rabbitmq-server ...\n")
	if (shellExec("mysudo ls -ld /var/lib/rabbitmq |awk '{print $3}'") != "rabbitmq") or (shellExec("mysudo ls -ld /var/lib/rabbitmq |awk '{print $4}'") != "rabbitmq") or (shellExec("mysudo ls -ld /var/log/rabbitmq |awk '{print $3}'") != "rabbitmq") or (shellExec("mysudo ls -ld /var/log/rabbitmq |awk '{print $4}'") != "rabbitmq"):
	    shellExec("mysudo check_user rabbitmq")
	    if (shellExec("mysudo echo $?") == "0"):
		shellExec("mysudo useradd rabbitmq")
	    shellExec("mysudo chown -R rabbitmq:rabbitmq /var/lib/rabbitmq /var/log/rabbitmq")
	
	shellExec("mysudo systemctl restart rabbitmq-server")
	RABBITMQ_SERVER_STATUS=shellExec("mysudo systemctl list-units --all --type=service |grep rabbitmq-server |awk '{print $4}'")
	if (RABBITMQ_SERVER_STATUS != "running"):
	    myprint("[ERROR] EXIT because rabbitmq-server configure failed\n", 'error')
	    shellExec("mysudo rm -rf /opt/softwarecenter/.SOFTINI_DATE_ORIG")
	    fileWrite("ConfigError : rabbitmq-server failed to start", "/opt/softwarecenter/.SOFT_FLAG")
	    myprint("\n")
	    myprint("[ERROR] Please contact your system administrator or operation and maintenance personnel, and use the successful Kylin Software Center after troubleshooting. \n", 'error')
	    myprint("\n")
	    time.sleep(5)
	    sys.exit()
	    
    STATUS = "[INFO] rabbitmq-server is" + RABBITMQ_SERVER_STATUS + "\n"
    myprint(STATUS, 'info')
    myprint("[INFO] configuring rabbitmq-server user ...\n", 'info')
    RABBITMQ_USER_SCS=shellExec("mysudo rabbitmqctl list_users |grep scs |awk '{print $1}'")
    if (RABBITMQ_USER_SCS == "scs") :
	message = shellExec("mysudo rabbitmqctl delete_user scs") + "\n"
	myprint(message)
    
    message = shellExec("mysudo rabbitmqctl add_user scs qwe123") + "\n"
    myprint(message)

    message = shellExec("mysudo rabbitmqctl set_user_tags scs administrator") + "\n"
    myprint(message)

    message = shellExec(r'mysudo rabbitmqctl set_permissions -p / scs \".*\" \".*\" \".*\"') + "\n"
    myprint(message)

    if (shellExec("mysudo echo $?") != "0"):
	myprint("[ERROR] rabbitmq-server user config failed!\n", 'error')
	shellExec("mysudo rm -rf /opt/softwarecenter/.SOFTINI_DATE_ORIG")
	fileWrite("ConfigError : rabbitmq-server user config failed", "/opt/softwarecenter/.SOFT_FLAG")
	myprint("\n")
	time.sleep(5)
	sys.exit()
    else:
	myprint("[INFO] configure rabbitmq-server success!\n", 'info')
    
    myprint("\n")
    myprint("[INFO] initial sqlite database ...\n", 'info')
    shellExec("mysudo /usr/sbin/packageinfo")
    shellExec("mysudo chmod 777 /opt/softwarecenter/db/server_software.db")
    shellExec(r"mysudo sqlite3 /opt/softwarecenter/db/server_software.db \"delete from softwares\"")
    if (shellExec("mysudo echo $?") != "0"):
	myprint("rERROR] initial sqlite database failed!\n", 'error')
	shellExec("mysudo rm -rf /opt/softwarecenter/.SOFTINI_DATE_ORIG")
	fileWrite("ConfigError : initial sqlite database failed", "/opt/softwarecenter/.SOFT_FLAG")
	myprint("\n")
	time.sleep(5)
	sys.exit()
    else:
	myprint("[INFO] initial sqlite database success!\n", 'info')
    
    myprint("\n")
    myprint("[INFO] checking firewalld service ...\n", 'info')
    FIREWALLD_STATUS=shellExec("mysudo systemctl list-units --all --type=service |grep firewalld |awk '{print $4}'")
    if (FIREWALLD_STATUS == "running") :
	STATUS = "[INFO] firewalld is" + FIREWALLD_STATUS + "\n"
	myprint(STATUS, 'info')
	myprint("[INFO] configure firewalld ...\n", 'info')
	shellExec("mysudo firewall-cmd --permanent --add-port={5672/tcp,5672/udp}")
	shellExec("mysudo firewall-cmd --reload")
    else:
	myprint("[INFO] stop & disable firewalld ...\n", 'info')
	shellExec("mysudo systemctl disable firewalld")
	shellExec("mysudo systemctl stop firewalld")
    
    if (shellExec("mysudo echo $?") != "0"):
	myprint("[ERROR] configure firewalld service failed!\n", 'error')
	shellExec("mysudo rm -rf /opt/softwarecenter/.SOFTINI_DATE_ORIG")
	fileWrite("ConfigError : configure firewalld service failed", "/opt/softwarecenter/.SOFT_FLAG")
	myprint("\n")
	time.sleep(5)
	sys.exit()
    else:
	myprint("[INFO] configure firewalld service success!\n", 'info')
    
    myprint("\n")
    myprint("[INFO] Software Center Client Init END\n", 'info')
    myprint("\n")
    myprint("[INFO] Software Center Client Init END\n", 'info')
    myprint("[INFO] INIT END...\n", 'info')
    message = "mysudo echo '" + INI_DATE + r"' \> /opt/softwarecenter/.SOFTINI_DATE_ORIG"
    shellExec(message)
    time.sleep(3)
    sys.exit()

def zh_cn_utf8():
    if (INIT_MY_NAME != "root" and (fileRead() != 1)):
	myprint("[ERROR] 中标麒麟软件中心初始化失败！\n", 'error')
	myprint("[ERROR] 请在终端中编辑 /opt/softwarecenter/doc/mysudo.conf ，然后再执行中标麒麟软件中心的初始化脚本：\n", 'error')
	myprint("\n")
	myprint("     /usr/share/doc/software-center/scc-init.py\n")
	myprint("\n")
	myprint("[ERROR] 中标麒麟软件中心初始化脚本 退出...\n", 'error')
	if (SC_PPID != ""):
	    #kill -9 `echo $SC_PPID`
	    myprint("\n")
	
	shellNotify("请在终端中编辑 mysudo.conf 再执行:", "/usr/share/doc/software-center/scc-init.py", 20000)
	message = "当前用户 " + INIT_MY_NAME + " 的 mysudo.conf 可能不正确。"
	shellNotify("中标麒麟软件中心初始化失败! ", message, 5000)

	time.sleep(2)
	sys.exit()

    if (PS_SOFTCENTER == "/usr/sbin/softCenter") :
	myprint("[ERROR] 中标麒麟软件中心正在运行，此时您不能执行软件中心初始化程序！\n", 'error')
	myprint("[ERROR] 本初始化程序将自动退出...\n", 'error')
	shellExec("mysudo rm -rf /opt/softwarecenter/.SOFTINI_DATE_ORIG")
	time.sleep(3)
	sys.exit()
    
    myprint("[INFO] 您看到此内容则表明:\n", 'info')
    myprint("[INFO]         1，您可能是首次打开中标麒麟软件中心\n", 'info')
    myprint("[INFO]         2，您可能最近更新过中标麒麟软件中心\n", 'info')
    myprint("[INFO]         3，您可能最近修改过中标麒麟软件中心的配置文件\n", 'info')
    myprint("\n")
    myprint("[INFO] 正在执行中标麒麟软件中心的初始化程序...\n", 'info')
    myprint("[INFO] 请耐心等待...\n", 'info')
    myprint("\n")
    myprint("[INFO] 通信服务配置...\n", 'info')
    useradd_fix_for_systemd_update()
    shellExec("mysudo systemctl restart rabbitmq-server")
    shellExec("mysudo systemctl enable rabbitmq-server")
    myprint("[INFO] 通信服务状态检测...\n", 'info')
    RABBITMQ_SERVER_STATUS=shellExec("mysudo systemctl list-units --all --type=service |grep rabbitmq-server |awk '{print $4}'")
    if (RABBITMQ_SERVER_STATUS != "running"):
	status = "[WARNING] 通信服务状态为:  " + RABBITMQ_SERVER_STATUS + "\n"
	myprint(status)
	myprint("[WARNING] 正在尝试重启通信服务...\n")
	if (shellExec("mysudo ls -ld /var/lib/rabbitmq |awk '{print $3}'") != "rabbitmq") or (shellExec("mysudo ls -ld /var/lib/rabbitmq |awk '{print $4}'") != "rabbitmq") or (shellExec("mysudo ls -ld /var/log/rabbitmq |awk '{print $3}'") != "rabbitmq") or (shellExec("mysudo ls -ld /var/log/rabbitmq |awk '{print $4}'") != "rabbitmq"):
	    shellExec("mysudo check_user rabbitmq")
	    if (shellExec("mysudo echo $?") == "0"):
		shellExec("mysudo useradd rabbitmq")
	    shellExec("mysudo chown -R rabbitmq:rabbitmq /var/lib/rabbitmq /var/log/rabbitmq")
	
	shellExec("mysudo systemctl restart rabbitmq-server")
	RABBITMQ_SERVER_STATUS=shellExec("mysudo systemctl list-units --all --type=service |grep rabbitmq-server |awk '{print $4}'")
	if (RABBITMQ_SERVER_STATUS != "running"):
	    myprint("[ERROR] 故障！！！通信服务重启失败！\n", 'error')
	    shellExec("mysudo rm -rf /opt/softwarecenter/.SOFTINI_DATE_ORIG")
	    fileWrite("ConfigError : 通信服务启动失败", "/opt/softwarecenter/.SOFT_FLAG")
	    myprint("\n")
	    myprint("[ERROR] 请联系您的系统管理员或运维人员，待故障排除后再使用中标麒麟软件中心。\n", 'error')
	    myprint("\n")
	    time.sleep(5)
	    sys.exit()
    
    STATUS = "[INFO] 通信服务状态为: " + RABBITMQ_SERVER_STATUS + "\n"
    myprint(STATUS, 'info')

    myprint("[INFO] 通信服务后台用户配置...\n", 'info')
    RABBITMQ_USER_SCS=shellExec("mysudo rabbitmqctl list_users |grep scs |awk '{print $1}'")
    if (RABBITMQ_USER_SCS == "scs"):
	message = shellExec("mysudo rabbitmqctl delete_user scs") + "\n"
	myprint(message)
    
    message = shellExec("mysudo rabbitmqctl add_user scs qwe123") + "\n"
    myprint(message)

    message = shellExec("mysudo rabbitmqctl set_user_tags scs administrator") + "\n"
    myprint(message)

    message = shellExec(r'mysudo rabbitmqctl set_permissions -p / scs \".*\" \".*\" \".*\"') + "\n"
    myprint(message)

    if (shellExec("mysudo echo $?") != "0"):
	myprint("[ERROR] 通信服务后台用户配置失败！ 故障！！！\n", 'error')
	shellExec("mysudo rm -rf /opt/softwarecenter/.SOFTINI_DATE_ORIG")
	fileWrite("ConfigError : 通信服务后台用户配置失败", "/opt/softwarecenter/.SOFT_FLAG")
	myprint("[ERROR] 请联系您的系统管理员或运维人员，待故障排除后再使用中标麒麟软件中心。\n", 'error')
	myprint("\n")
	time.sleep(5)
	sys.exit()
    else:
	myprint("[INFO] 通信服务配置完成。\n", 'info')
    
    myprint("\n")
    myprint("[INFO] 数据库初始化...\n", 'info')
    shellExec("mysudo /usr/sbin/packageinfo")
    shellExec("mysudo chmod 777 /opt/softwarecenter/db/server_software.db")
    shellExec(r'mysudo sqlite3 /opt/softwarecenter/db/server_software.db \"delete from softwares\" ')
    if (shellExec("mysudo echo $?") != "0"):
	myprint("[ERROR] 数据库初始化失败！ 故障！！！\n", 'error')
	shellExec("mysudo rm -rf /opt/softwarecenter/.SOFTINI_DATE_ORIG")
	fileWrite("ConfigError : 数据库初始化失败", "/opt/softwarecenter/.SOFT_FLAG")
	myprint("[ERROR] 请联系您的系统管理员或运维人员，待故障排除后再使用中标麒麟软件中心。\n", 'error')
	myprint("\n")
	time.sleep(5)
	sys.exit()
    else:
	    myprint("[INFO] 数据库初始化完成。\n", 'info')
    
    myprint("\n")
    myprint("[INFO] 防火墙服务状态检测...\n", 'info')
    FIREWALLD_STATUS=shellExec("mysudo systemctl list-units --all --type=service |grep firewalld |awk '{print $4}'")
    if (FIREWALLD_STATUS == "running") :
	STATUS = "[INFO] 防火墙服务状态为: " + FIREWALLD_STATUS + "\n"
	myprint(STATUS, 'info')
	myprint("[INFO] 防火墙通信端口设置...\n", 'info')
	shellExec("mysudo firewall-cmd --permanent --add-port={5672/tcp,5672/udp}")
	shellExec("mysudo firewall-cmd --reload")
    else:
	myprint("[INFO] 防火墙服务将被禁用...\n", 'info')
	shellExec("mysudo systemctl disable firewalld")
	shellExec("mysudo systemctl stop firewalld")
    
    if (shellExec("mysudo echo $?") != "0"):
	myprint("[ERROR] 防火墙服务配置失败！ 故障！！！\n", 'error')
	shellExec("mysudo rm -rf /opt/softwarecenter/.SOFTINI_DATE_ORIG")
	fileWrite("ConfigError : 防火墙服务配置失败", "/opt/softwarecenter/.SOFT_FLAG")
	myprint("[ERROR] 请联系您的系统管理员或运维人员，待故障排除后再使用中标麒麟软件中心。\n", 'error')
	myprint("\n")
	time.sleep(5)
	sys.exit()
    else:
	myprint("[INFO] 防火墙服务配置完成。\n", 'info')
    
    message = "mysudo echo '" + INI_DATE + r"' \> /opt/softwarecenter/.SOFTINI_DATE_ORIG"
    shellExec(message)
    myprint("\n")
    myprint("[INFO] 初始化完成。\n", 'info')
    myprint("[INFO] 初始化程序 即将退出...\n", 'info')
    myprint("\n")
    #myprint("[INFO] 随后将启动中标麒麟软件中心...", 'info')
    time.sleep(3)
    sys.exit()


if __name__ == '__main__':
    #创建窗口
    win=Tk()
    #标题
    win.title("Software Center Init")

    #窗口基于屏幕的坐标 +x轴+y轴
    #win.geometry("500x380+200+0")

    #设置窗口大小
    width = 580
    height = 500
    #获取屏幕尺寸以计算布局参数，使窗口居屏幕中央
    screenwidth = win.winfo_screenwidth() 
    screenheight = win.winfo_screenheight()
    alignstr = '%dx%d+%d+%d' % (width, height, (screenwidth-width)/2, (screenheight-height)/2)
    win.geometry(alignstr)

    text=Text(win, bg='black', fg='green', font=("微软雅黑", 12), width=1000,height=800 )

    # deal function
    if (LANGUAGE != "zh_CN.UTF-8") and  (LANGUAGE != "zh_CN.utf-8"):
	otherLanguage()
    else:
	zh_cn_utf8()

    win.mainloop()

